/* assembler tokens
#token struct mult_list_t TOK_MULT_LIST =
#token struct processor_t *TOK_PROCESSOR = 
#token struct proc_instr_t *TOK_PROC_INSTR =
#token struct proc_instr_arg_t *TOK_PROC_INSTR_ARG =
#token void TOK_LITTLE_ENDIAN = /"LITTLE ENDIAN"/ {} & {WRITE("LITTLE ENDIAN");}
#token void TOK_BIG_ENDIAN = /"BIG ENDIAN"/ {} & {WRITE("BIG ENDIAN");}
#token void TOK_ADDINSTR = /{DIR}addinstr{SPACES}\/\\\[/ {} 
                         | /{DIR}addinstr{SPACES}/ {BEGIN TASMTABNAME;}
                         & {WRITE("#addinstr ");}
#token int TOK_BYTE_INT = /\\`[0-9a-fA-F]{2}\\`/ {$$ = strtol(yytext+1,NULL,16);}
                        & {CHECK_UNSIGNED($$,0xff); WRITE("`%02hhX`", $$);}
#token int TOK_WORD_INT = /\\`[0-9a-fA-F]{4}\\`/ {$$ = strtol(yytext+1,NULL,16);} 
                        & {CHECK_UNSIGNED($$,0xffff); WRITE("`%04hX`", $$);}
#token int TOK_DWORD_INT = /\\`[0-9a-fA-F]{8}\\`/ {$$ = strtol(yytext+1,NULL,16);} 
                         & {CHECK_UNSIGNED($$,0xffffffff); WRITE("`%08lX`", $$);}
#token int *TOK_BYTE_INT_P = & {CHECK_UNSIGNED(*($$),0xff); WRITE("`%02hhX`", *($$));}
#token int *TOK_WORD_INT_P = & {CHECK_UNSIGNED(*($$),0xffff); WRITE("`%04hX`", *($$));}
#token int *TOK_DWORD_INT_P = & {CHECK_UNSIGNED(*($$),0xffffffff); WRITE("`%08lX`", *($$));}
#token int TOK_SIGNED_BYTE_INT = & {CHECK_SIGNED($$,0xff); WRITE("`%02hhX`", $$);}
#token int TOK_SIGNED_WORD_INT = & {CHECK_SIGNED($$,0xffff); WRITE("`%04hX`", $$);}
#token int TOK_SIGNED_DWORD_INT = & {CHECK_SIGNED($$,0xffffffff); WRITE("`%08lX`", $$);}
#token int *TOK_SIGNED_BYTE_INT_P = & {CHECK_SIGNED(*($$),0xff); WRITE("`%02hhX`", *($$));}
#token int *TOK_SIGNED_WORD_INT_P = & {CHECK_SIGNED(*($$),0xffff); WRITE("`%04hX`", *($$));}
#token int *TOK_SIGNED_DWORD_INT_P = & {CHECK_SIGNED(*($$),0xffffffff); WRITE("`%08lX`", *($$));}
#token void TOK_BYTE = /{DIR}byte/ {} & {WRITE("#byte ");}
#token void TOK_WORD = /{DIR}word/ {} & {WRITE("#word ");}
#token void TOK_DWORD = /{DIR}dword/ {} & {WRITE("#dword ");}
#token void TOK_SIGNED_BYTE = /{DIR}sbyte/ {} & {WRITE("#sbyte ");}
#token void TOK_SIGNED_WORD = /{DIR}sword/ {} & {WRITE("#sword ");}
#token void TOK_SIGNED_DWORD = /{DIR}sdword/ {} & {WRITE("#sdword ");}
#token int TOK_ARG = /@[0-9]+/ {$$ = strtol(yytext+1, NULL,16);} & {WRITE("@%i", $$);}

#token void TOK_DB = /{DIR}[dD][bB]/ {}
                   | /{DIR}[tT][eE][xX][tT]/ {}
                   | /[dD][bB]/ {}
                   & {WRITE(".db ");}
#token void TOK_DW = /{DIR}[dD][wW]/ {}
                   | /[dD][wW]/ {}
                   & {WRITE(".dw ");}
#token void TOK_DD = /{DIR}[dD][dD]/ {}
                   | /[dD][dD]/ {}
                   & {WRITE(".dd ");}

*/
