#ifndef ZASM_HASH_TABLE_H
#define ZASM_HASH_TABLE_H 1

#define ZASM_HASH_TABLE_SIZE 4096

#define HASH_ENTRY_T(O) ((struct hash_entry_t *)(O))
// pure virtual base class
struct hash_entry_t
{
  // public
  char *name;
  struct hash_entry_t *next;
};

#define HASH_TABLE_T(O) ((struct hash_table_t *)(O))
struct hash_table_t
{
  // private
  struct hash_entry_t *table[ZASM_HASH_TABLE_SIZE];
};

struct hash_table_t *hash_table_new();
void hash_table_fill(struct hash_table_t *table);
struct hash_entry_t **hash_table_lookup(struct hash_table_t *table, char *name);
void hash_table_delete(struct hash_table_t *table);
void hash_table_free(struct hash_table_t *table);

void hash_entry_fill(struct hash_entry_t *entry, char *name);
void hash_entry_unlink(struct hash_entry_t **entry);
void hash_entry_delete(struct hash_entry_t *entry);

#endif
