#ifndef ZASM_PP_NAMESPACE_H
#define ZASM_PP_NAMESPACE_H 1

#include <zasm/namespace.h>

#define PP_NAMESPACE_T(O) ((struct pp_namespace_t *)(O))
struct pp_namespace_t
{
  struct namespace_t namespace;
};

#define PP_LEVEL_T(O) ((struct pp_level_t *)(O))
struct pp_level_t
{
  // public
  struct ns_level_t level;
  
  struct string_alloc_t *string_alloc;
  struct pp_entry_alloc_t *entry_alloc;
  struct pp_macro_alloc_t *macro_alloc;
};

#include <zasm/pp_entry.h>
#include <zasm/pp_macro.h>
#include <zasm/string_alloc.h>
#include <zasm/list.h>
struct pp_namespace_t *pp_namespace_new();
void pp_namespace_fill(struct pp_namespace_t *ns);
void pp_namespace_add_level(struct pp_namespace_t *ns);
void pp_namespace_del_level(struct pp_namespace_t *ns);
void pp_namespace_define(struct pp_namespace_t *ns, char *name, struct list_t *args, struct list_t *body);
int  pp_namespace_defined(struct pp_namespace_t *ns, char *name);
void pp_namespace_redef(struct pp_namespace_t *ns, char *name, struct list_t *args, struct list_t *body);
void pp_namespace_del(struct pp_namespace_t *ns, char *name);
struct pp_macro_t *pp_namespace_lookup(struct pp_namespace_t *ns, char *name);
struct pp_macro_t *pp_namespace_lookup_local(struct pp_namespace_t *ns, char *name);
void pp_namespace_delete(struct pp_namespace_t *ns);
void pp_namespace_free(struct pp_namespace_t *ns);

struct pp_level_t *pp_level_new(struct pp_namespace_t *parent);
void pp_level_fill(struct pp_level_t *level, struct pp_namespace_t *parent);
void pp_level_delete(struct pp_level_t *level);
void pp_level_free(struct pp_level_t *level);

#endif
